// init
$(function(){
    
    // add a css class on the body tag in order to tweak the UI based on browser if needed.
    var bodyBrowserClass = "";
    if ( $.browser.msie ) {
      bodyBrowserClass = "ie ie"+parseInt($.browser.version, 10);
    } else if ( $.browser.webkit ) {
      bodyBrowserClass = "webkit webkit"+parseInt($.browser.version, 10);
    } else if ( $.browser.opera ) {
      bodyBrowserClass = "opera opera"+parseInt($.browser.version, 10);
    } else if ( $.browser.mozilla ) {
      bodyBrowserClass = "moz moz"+parseInt($.browser.version, 10);
    }
    $(document.body).addClass(bodyBrowserClass);
    
    var supportedBrowser = false;
    if (
            (BrowserDetect.browser == "Firefox" && BrowserDetect.version >= 10) ||
            (BrowserDetect.browser == "Safari" && BrowserDetect.version >= 5) ||
            (BrowserDetect.browser == "Chrome" && BrowserDetect.version >= 17) ||
            (BrowserDetect.browser == "Explorer" && BrowserDetect.version >= 8)
        ) {
        supportedBrowser = true;
    }
    
    if (!supportedBrowser) {
        var skipBrowserWarning = getCookie("skipBrowserWarning");
        var isMobileDevice = detectMobileDevice(navigator.userAgent||navigator.vendor||window.opera);
        if (isMobileDevice && !BrowserDetect.OS == "iPad") return; // dont warn for mobile devices other than ipad
        if (!skipBrowserWarning) {
            $('#obWrapper').load(baseUri + 'browserWarning');        
        }
    }
    
    // setup modal message div to receive calls
    $('#modalMessage').dialog({
        autoOpen: false,
        height: 140,
        modal: true
    });
});

/* need to use this for better detection of actual browsers and their versions
 * rather than just the rendering engines and versions than the jQuery 
 * $.browser.xxxx api provides
 */
var BrowserDetect = {
	init: function () {
		this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
		this.version = this.searchVersion(navigator.userAgent)
			|| this.searchVersion(navigator.appVersion)
			|| "an unknown version";
		this.OS = this.searchString(this.dataOS) || "an unknown OS";
	},
	searchString: function (data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].string;
			var dataProp = data[i].prop;
			this.versionSearchString = data[i].versionSearch || data[i].identity;
			if (dataString) {
				if (dataString.indexOf(data[i].subString) != -1)
					return data[i].identity;
			}
			else if (dataProp)
				return data[i].identity;
		}
	},
	searchVersion: function (dataString) {
		var index = dataString.indexOf(this.versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	},
	dataBrowser: [
		{
			string: navigator.userAgent,
			subString: "Chrome",
			identity: "Chrome"
		},
		{ 	string: navigator.userAgent,
			subString: "OmniWeb",
			versionSearch: "OmniWeb/",
			identity: "OmniWeb"
		},
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: "Safari",
			versionSearch: "Version"
		},
		{
			prop: window.opera,
			identity: "Opera",
			versionSearch: "Version"
		},
		{
			string: navigator.vendor,
			subString: "iCab",
			identity: "iCab"
		},
		{
			string: navigator.vendor,
			subString: "KDE",
			identity: "Konqueror"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: "Firefox"
		},
		{
			string: navigator.vendor,
			subString: "Camino",
			identity: "Camino"
		},
		{		// for newer Netscapes (6+)
			string: navigator.userAgent,
			subString: "Netscape",
			identity: "Netscape"
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: "Explorer",
			versionSearch: "MSIE"
		},
		{
			string: navigator.userAgent,
			subString: "Gecko",
			identity: "Mozilla",
			versionSearch: "rv"
		},
		{ 		// for older Netscapes (4-)
			string: navigator.userAgent,
			subString: "Mozilla",
			identity: "Netscape",
			versionSearch: "Mozilla"
		}
	],
	dataOS : [
		{
			string: navigator.platform,
			subString: "Win",
			identity: "Windows"
		},
		{
			string: navigator.platform,
			subString: "Mac",
			identity: "Mac"
		},
		{
            string: navigator.userAgent,
            subString: "iPhone",
            identity: "iPhone/iPod"
	    },
		{
            string: navigator.userAgent,
            subString: "iPad",
            identity: "iPad"
	    },
		{
			string: navigator.platform,
			subString: "Linux",
			identity: "Linux"
		}
	]

};
BrowserDetect.init();

function detectMobileDevice(a){
    if(/android.+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|e\-|e\/|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(di|rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|xda(\-|2|g)|yas\-|your|zeto|zte\-/i.test(a.substr(0,4)))
        return true;
    else 
        return false;
}

/**
 * create a form vaidator instance
 */
function AWPvalidate(formEl,submitFunction) {
    $(formEl).validate({
        errorPlacement: function (error, element) {

            $(error).tooltip({
                bodyHandler: function() {
                    return $(error).text();
                },
                track: true,
                delay: 0,
                showURL: false,
                extraClass:"flagtip error"
            });

            error.insertAfter(element);

        },
        submitHandler: function(form) {

            if (submitFunction) {
                submitFunction()
            } else {
                form.submit();
            }
        }
    });
}

/**
 * Show a modal popup message
 */
function showModalMessage(message, title){
    var $messageDiv = $('#modalMessage');
    if(title){
        $messageDiv.dialog( "option", "title", title );
    }
    $('#modalMessage p').html(message);
    $messageDiv.dialog('open');
}


/**
 * Show an error using the pines notify popup
 */
var stack_login_custom = {"dir1": "down", "dir2": "right", "push": "bottom",
    "firstpos1": ($(window).height() / 2) - 60, "firstpos2": ($(window).width() / 2) - 100 };

function showError(title, text) {
    $.pnotify({
        pnotify_title: title,
        pnotify_text: text,
        pnotify_type: "error",
        pnotify_shadow: true,
        pnotify_stack: stack_login_custom
    });
}

function setCookie(c_name,value,exdays) {
    var exdate=new Date();
    exdate.setDate(exdate.getDate() + exdays);
    var c_value=escape(value) + ((exdays==null) ? "" : "; expires="+exdate.toUTCString());
    document.cookie=c_name + "=" + c_value;
}

function getCookie(c_name) {
    var i,x,y,ARRcookies=document.cookie.split(";");
    for (i=0;i<ARRcookies.length;i++) {
        x=ARRcookies[i].substr(0,ARRcookies[i].indexOf("="));
        y=ARRcookies[i].substr(ARRcookies[i].indexOf("=")+1);
        x=x.replace(/^\s+|\s+$/g,"");
        if (x==c_name) {
            return unescape(y);
        }
    }
}

function readCookie(c_name) {
    return getCookie(c_name);
}

function deleteCookie(c_name) {
    document.cookie = c_name + '=; expires=Thu, 01-Jan-70 00:00:01 GMT;';
}


function is_int(value) {
    if((parseFloat(value) == parseInt(value)) && !isNaN(value)){
        return true;
    } else {
        return false;
    }
}

